﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using LEAPI;

namespace LA2R3AsampleCsharp
{
    public partial class LA2R3ASAMPLE : Form
    {
        bool connected = false;
        int lanio = 0;

        public LA2R3ASAMPLE()
        {
            InitializeComponent();
            LALanio.Init();
        }

        ~LA2R3ASAMPLE()
        {
            LALanio.End();
        }

        private void CONNECT_CheckedChanged(object sender, EventArgs e)
        {
            if (CONNECT.Checked)
            {
                try
                {
                    connect(ref lanio);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                    CONNECT.Checked = false;
                    return;
                }
                connected = true;
            }
            else
            {
                LALanio.Close(lanio);
                connected = false;
            }
        }

        private void OUTPUT_Click(object sender, EventArgs e)
        {
            if (connected != true)
            {
                MessageBox.Show("not connected");
                return;
            }
            try
            {
                output(lanio);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void INPUT_Click(object sender, EventArgs e)
        {
            if (connected != true)
            {
                MessageBox.Show("not connected");
                return;
            }
            try
            {
                input(lanio);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void connect(ref int lanio)
        {
            string ipaddress = IPADDRESS.Text;
            lanio = LALanio.ConnectDirect(ipaddress, 2000);
            if( lanio == -1 ){
                throw new Exception("Connect error");
            }
        }

        private void output(int lanio)
        {
            int err, d_out;
            d_out = (DO1.Checked ? 0x01 : 0) |
                  (DO2.Checked ? 0x02 : 0);
            err = LALanio.DO(lanio, d_out);
            if( err == 0 ){
                throw new Exception("Output error");
            }
        }

        private void input(int lanio)
        {
            int err;
            int[] inarray = new int[5];
            IntPtr inptr = Marshal.AllocCoTaskMem(Marshal.SizeOf(typeof(int)) * 5);
            err = LALanio.AIAll(lanio, inptr);
            Marshal.Copy(inptr, inarray, 0, 5);
            Marshal.FreeCoTaskMem(inptr);
            if (err == 0)
            {
                throw new Exception("Input error"); 
            }
            AI1.Text = inarray[0].ToString();
            AI2.Text = inarray[1].ToString();
            AI3.Text = inarray[2].ToString();
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void IPADDRESS_TextChanged(object sender, EventArgs e)
        {

        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void DO2_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void DO1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }

        private void label4_Click(object sender, EventArgs e)
        {

        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void AI3_TextChanged(object sender, EventArgs e)
        {

        }

        private void AI2_TextChanged(object sender, EventArgs e)
        {

        }

        private void AI1_TextChanged(object sender, EventArgs e)
        {

        }
    }
}
